VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cldLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License, incorporated herein by reference.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.geocities.co.jp/SiliconValley-Oakland/1731/
'--------------------------------------------------------------------------------------------------=

Private m_nID As Long
Private m_sgStartT As Single
Private m_sgEndT As Single
Private m_sText As String
Private m_nStatus As Integer
Private m_sNote As String

Private Const S1 = 1
Private Const S2 = 2

Public Property Let ID(nID As Long)
    m_nID = nID
End Property

Public Property Get ID() As Long
    ID = m_nID
End Property

Public Property Let StartT(sgTmp As Single)
    m_sgStartT = sgTmp
End Property

Public Property Get StartT() As Single
    StartT = m_sgStartT
End Property

Public Property Let EndT(sgTmp As Single)
    m_sgEndT = sgTmp
End Property

Public Property Get EndT() As Single
    EndT = m_sgEndT
End Property

Public Property Let Text(sTmp As String)
    m_sText = sTmp
End Property

Public Property Get Text() As String
    Text = m_sText
End Property

Public Property Let Status(nTmp As Integer)
    m_nStatus = nTmp
End Property

Public Property Get Status() As Integer
    Status = m_nStatus
End Property

Public Property Let Note(sTmp As String)
    m_sNote = sTmp
End Property

Public Property Get Note() As String
    Note = m_sNote
End Property

'Parsing logic:
'1.If the line is empty, the program ignores it.
'2.If the first column is not numeric, the program thinks of the line
'  doesn't have timing information and make up a tentative one. ("from 99999 to 99999")
'3.If the second column is numeric, the program thinks of
'  the line as the one with the timing information in the version 2 format.
'4.Otherwise the program thinks of the line as the one with the timing information
'  in the version 1 format.
Public Function Parse(sSource As String) As Boolean
    Dim sTmp As String
    Dim lIndexOld As Long
    Dim lIndexNew As Long
    Dim col As New Collection

    Parse = True
    If sSource = "" Then
        Parse = False
        Exit Function
    End If
    
On Error GoTo errHandler
    lIndexOld = 1
    Do While True
        lIndexNew = InStr(lIndexOld, sSource, vbTab)
        If lIndexNew < 1 Then
            col.Add Mid$(sSource, lIndexOld)
            Exit Do
        End If
        col.Add Mid$(sSource, lIndexOld, lIndexNew - lIndexOld)
        lIndexOld = lIndexNew + 1
    Loop
    If Not IsNumeric(col.Item(1)) Then
        StartT = 99999
        EndT = 99999
        Text = col.Item(1)
        Exit Function
    End If
    StartT = MyRound(CSng(col.Item(1)) / 100)
    If IsNumeric(col.Item(2)) Then
        EndT = MyRound(CSng(col.Item(2)) / 100)
        Text = col.Item(3)
    Else
        'Backward compatibility for version 1 style script file
        EndT = MyRound(CSng(col.Item(3)) / 100)
        Text = col.Item(2)
    End If
    If col.Count >= 4 Then
         Status = CLng(col.Item(4))
    End If
    If col.Count >= 5 Then
         Note = Unescape(col.Item(5))
    End If
    Exit Function
errHandler:
    Parse = False
    'MsgBox Err.Description

    Debug.Print "cldLine!Parse error sSource = " & sSource
End Function

Public Function Serialize() As String
    'version 2 style
    Serialize = MyRound2(Int(StartT * 100)) & vbTab & _
        MyRound2(Int(EndT * 100)) & vbTab & Text & vbTab _
        & Status & vbTab & Escape(Note)
End Function

Public Sub Play()
    Call MCICommand("play w " & "from " & _
                    Int(StartT * g_GFactor) & _
                    " to " & Int(EndT * g_GFactor))
End Sub

Public Sub ShortPlay()
    Dim st As Single
    st = EndT - 0.5
    If st < StartT Then st = StartT
    Call MCICommand("play w " & "from " & _
                    Int(st * g_GFactor) & _
                    " to " & Int(EndT * g_GFactor))
End Sub


Private Function Escape(sIn As String) As String
    Dim i As Long
    Dim state As Long
    Dim res As String
    Dim ch As String
    
    state = S1
    res = ""
    For i = 1 To Len(sIn)
        ch = Mid$(sIn, i, 1)
        Select Case state
        Case S1
            Select Case ch
            Case vbCr
                state = S2
            Case "\"
                res = res & "\\"
            Case Else
                res = res & ch
            End Select
        Case S2
            Select Case ch
            Case vbLf
                res = res & "\"
            Case Else
                res = res & vbCr & ch
            End Select
            state = S1
        End Select
    Next
    If state = S2 Then
        res = res & vbCr
    End If

    Escape = res
End Function

Private Function Unescape(sIn As String) As String
    Dim i As Long
    Dim state As Long
    Dim res As String
    Dim ch As String

    state = S1
    res = ""
    For i = 1 To Len(sIn)
        ch = Mid$(sIn, i, 1)
        Select Case state
        Case S1
            Select Case ch
            Case "\"
                state = S2
            Case Else
                res = res & ch
            End Select
        Case S2
            Select Case ch
            Case "\"
                res = res & "\"
            Case Else
                res = res & vbCr & vbLf & ch
            End Select
            state = S1
        End Select
    Next
    If state = S2 Then
        res = res & vbCr & vbLf
    End If
    
    Unescape = res
End Function

Private Function MyRound(ByVal X As Single) As Single
    'Round the digit of 1/100
    MyRound = Int(X * 10 + 0.5) / 10
End Function

Private Function MyRound2(ByVal X As Long) As Long
    'Round the digit of 1
    MyRound2 = ((X + 5) \ 10) * 10
End Function



