VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cldLines"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License, incorporated herein by reference.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.geocities.co.jp/SiliconValley-Oakland/1731/
'--------------------------------------------------------------------------------------------------=

Private lines As Collection

Private Sub Class_Initialize()
    Set lines = New Collection
End Sub

Public Sub Add(line As cldLine, ByVal sID As String)
    lines.Add line, sID
End Sub

Public Sub Remove(lIndex As Long)
    lines.Remove lIndex
End Sub

Public Sub RemoveByID(ByVal sID As String)
    lines.Remove sID
End Sub

Public Function Item(lIndex As Long) As cldLine
    Set Item = lines.Item(lIndex)
End Function

Public Function ItemByID(ByVal sID As String) As cldLine
    Set ItemByID = lines.Item(sID)
End Function

Public Function Count() As Long
    Count = lines.Count
End Function

Public Function NewEnum() As IUnknown
    Set NewEnum = lines.[_NewEnum]
End Function

Public Sub Read(sFilePath As String)
    Dim fno As Integer
    Dim sLine As String
    Dim line As cldLine
    Dim i As Integer
    
    Screen.MousePointer = vbHourglass
    
    Clear
    fno = FreeFile
    If Not fso.FileExists(sFilePath) Then Exit Sub
    Open sFilePath For Input As fno
    i = 1
    Do While Not EOF(fno)
        Line Input #fno, sLine
        Set line = New cldLine
        If line.Parse(sLine) Then
            line.ID = i
            Add line, CStr(i)
            i = i + 1
        End If
    Loop
    Close fno
    
    Screen.MousePointer = vbDefault
End Sub

Public Sub WriteTo(sFilePath As String)
    Dim fno As Integer
    Dim i As Integer
    Dim sLine As String
    Dim line As cldLine
    
    fno = FreeFile()
    Open sFilePath For Output As fno
    For Each line In lines
        sLine = line.Serialize
        Print #fno, sLine
    Next
    Close fno
End Sub

Public Sub Find(sKey As String)
    Dim i As Long
    Dim line As cldLine
    For i = Count To 1 Step -1
        Set line = lines.Item(i)
        'Text mode comparison
        If InStr(1, line.Text, sKey, vbTextCompare) = 0 Then
            lines.Remove i
        End If
    Next
End Sub

'shallow copy
Public Sub Copy(destLines As cldLines)
    Dim i As Long
    destLines.Clear
    For i = 1 To Count
        destLines.Add lines.Item(i), lines.Item(i).ID
    Next
End Sub

Public Sub Clear()
    Dim i As Long
    For i = Count() To 1 Step -1
        Remove i
    Next
End Sub


