Attribute VB_Name = "modMain"
Option Explicit
'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License, incorporated herein by reference.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.geocities.co.jp/SiliconValley-Oakland/1731/
'--------------------------------------------------------------------------------------------------=

Const UNCHECKED = 0
Const CHECKED = 1

Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
    (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Const SND_FILENAME = &H20000     '  name is a file name

Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _
    (ByVal lpstrCommand As String, ByVal _
    lpstrReturnString As Any, ByVal uReturnLength As Long, ByVal _
     hwndCallback As Long) As Long
     
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" (ByVal lpApplicationName _
    As String, ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long

Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" (ByVal lpApplicationName _
    As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, ByVal _
    lpFileName As String) As Long

Public sDataDir As String
Public g_lMciRes As Long
Public g_GFactor As Long

Public fso As FileSystemObject

Private m_sIniFileName As String

Sub Main()
    m_sIniFileName = MakePath$(App.Path, App.EXEName & ".ini")
    ReadVars
    g_GFactor = 1000
    Set fso = New Scripting.FileSystemObject
    frmMain.Show
End Sub

Public Sub ReadVars()
    sDataDir = GetProfile("DataDirectory", App.Path)
End Sub

Public Sub WriteVars()
    WriteProfile "DataDirectory", sDataDir
End Sub

Public Function GetProfile(sKey As String, Optional sDefault As String) As String
    Dim Temp As String * 50
    Dim sAppName As String, lpFileName As String
    Call GetPrivateProfileString("global", sKey, sDefault, Temp, Len(Temp), m_sIniFileName)
    GetProfile = TrimEx(Temp)
End Function

Public Function WriteProfile(sKey As String, sValue As String) As String
    Call WritePrivateProfileString("global", sKey, sValue, m_sIniFileName)
End Function

Public Function MCICommand(cmd As String) As String
 Dim RS As String, cb As Long
 Dim tmp As String
 
 RS = Space$(128)
 g_lMciRes = mciSendString(cmd, RS, 128, cb)
 tmp = Trim$(RS)
 MCICommand = Left$(tmp, Len(tmp) - 1)
End Function

Public Function GetFileWOExt(sFileName As String) As String
    Dim i As Long
    For i = Len(sFileName) To 1 Step -1
        If Mid$(sFileName, i, 1) = "." And i >= 2 Then
            GetFileWOExt = Left$(sFileName, i - 1)
            Exit Function
        End If
    Next
    GetFileWOExt = sFileName
End Function

Public Function GetFileNameOnly(sFileName As String) As String
    Dim i As Long
    For i = Len(sFileName) To 1 Step -1
        If Mid$(sFileName, i, 1) = "\" Then
            GetFileNameOnly = Right$(sFileName, Len(sFileName) - i)
            Exit Function
        End If
    Next
    GetFileNameOnly = sFileName
End Function

Public Sub SortNumber(lv As ListView, nColumnHeader As Long)
    Dim itm As ListItem
    Dim subitm As ListSubItem
    Dim format1 As String
    Dim format2 As String
    
    format1 = "00000000"
    format2 = "0.0"
   
    For Each itm In lv.ListItems
        Select Case nColumnHeader
            Case 1
                itm.Text = Format$(CSng(itm.Text) * 100, format1)
            Case Else
                Set subitm = itm.ListSubItems.Item(nColumnHeader - 1)
                subitm.Text = Format$(CSng(subitm.Text) * 100, format1)
        End Select
    Next
    
    lv.Sorted = False
    If lv.SortOrder = lvwDescending Then
       lv.SortOrder = lvwAscending
    Else
       lv.SortOrder = lvwDescending
    End If
    lv.SortKey = nColumnHeader - 1
    lv.Sorted = True
    
    For Each itm In lv.ListItems
        Select Case nColumnHeader
            Case 1
                itm.Text = Format$(CSng(itm.Text) / 100, format2)
            Case Else
                Set subitm = itm.ListSubItems.Item(nColumnHeader - 1)
                subitm.Text = Format$(CSng(subitm.Text) / 100, format2)
        End Select
    Next
End Sub

Public Function MakePath$(ByVal drv$, ByVal subdir$)

    Do While Right$(drv$, 1) = "\"
    drv$ = Left$(drv$, Len(drv$) - 1)
    Loop
    
    Do While Left$(subdir$, 1) = "\"
    subdir$ = Mid$(subdir, 2)
    Loop
    
    MakePath$ = drv$ + "\" + subdir$

End Function

'Strip characters whose code is under 32 on the both sides
Public Function TrimEx(ByVal s As String) As String
    Do While Asc(Right$(s, 1)) < 32
        s = Left$(s, Len(s) - 1)
    Loop
    
    Do While Asc(Left$(s, 1)) < 32
        s = Mid$(s, 2)
    Loop
    TrimEx = s
End Function


